# Class Vec3

java.lang.Object
com.codename1.gaming.physics.box2d.common.Vec3

All Implemented Interfaces:
  `Serializable`

public class Vec3 extends Object implements Serializable

See Also:
  - Serialized Form

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `float`
  `x`
  `float`
  `y`
  `float`
  `z`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `Vec3()`
  `Vec3(float argX, float argY, float argZ)`
  `Vec3(Vec3 argCopy)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Vec3`
  `add(Vec3 argVec)`
  `Vec3`
  `addLocal(Vec3 argVec)`
  `Vec3`
  `clone()`
  `static final Vec3`
  `cross(Vec3 a, Vec3 b)`
  `static final void`
  `crossToOut(Vec3 a, Vec3 b, Vec3 out)`
  `static final void`
  `crossToOutUnsafe(Vec3 a, Vec3 b, Vec3 out)`
  `static final float`
  `dot(Vec3 a, Vec3 b)`
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `int`
  `hashCode()`
  Returns a hash code value for the object.
  `Vec3`
  `mul(float argScalar)`
  `Vec3`
  `mulLocal(float argScalar)`
  `Vec3`
  `negate()`
  `Vec3`
  `negateLocal()`
  `Vec3`
  `set(float argX, float argY, float argZ)`
  `Vec3`
  `set(Vec3 argVec)`
  `void`
  `setZero()`
  `Vec3`
  `sub(Vec3 argVec)`
  `Vec3`
  `subLocal(Vec3 argVec)`
  `String`
  `toString()`
  Returns a string representation of the object.

  ### Methods inherited from class Object

  `getClass, notify, notifyAll, wait, wait, wait`

- ## Field Details

  - ### x

    public float x

  - ### y

    public float y

  - ### z

    public float z

- ## Constructor Details

  - ### Vec3

    public Vec3()

  - ### Vec3

    public Vec3(float argX, float argY, float argZ)

  - ### Vec3

    public Vec3(Vec3 argCopy)

- ## Method Details

  - ### set

    public Vec3 set(Vec3 argVec)

  - ### set

    public Vec3 set(float argX, float argY, float argZ)

  - ### addLocal

    public Vec3 addLocal(Vec3 argVec)

  - ### add

    public Vec3 add(Vec3 argVec)

  - ### subLocal

    public Vec3 subLocal(Vec3 argVec)

  - ### sub

    public Vec3 sub(Vec3 argVec)

  - ### mulLocal

    public Vec3 mulLocal(float argScalar)

  - ### mul

    public Vec3 mul(float argScalar)

  - ### negate

    public Vec3 negate()

  - ### negateLocal

    public Vec3 negateLocal()

  - ### setZero

    public void setZero()

  - ### clone

    public Vec3 clone()
    Overrides:
      `clone` in class `Object`

  - ### toString

    public String toString()
    Description copied from class: `Object`
    Returns a string representation of the object. In general, the toString method returns a string that "textually represents" this object. The result should be a concise but informative representation that is easy for a person to read. It is recommended that all subclasses override this method. The toString method for class Object returns a string consisting of the name of the class of which the object is an instance, the at-sign character `@', and the unsigned hexadecimal representation of the hash code of the object. In other words, this method returns a string equal to the value of: getClass().getName() + '@' + Integer.toHexString(hashCode())
    Overrides:
      `toString` in class `Object`

  - ### hashCode

    public int hashCode()
    Description copied from class: `Object`
    Returns a hash code value for the object. This method is supported for the benefit of hashtables such as those provided by java.util.Hashtable. The general contract of hashCode is: Whenever it is invoked on the same object more than once during an execution of a Java application, the hashCode method must consistently return the same integer, provided no information used in equals comparisons on the object is modified. This integer need not remain consistent from one execution of an application to another execution of the same application. If two objects are equal according to the equals(Object) method, then calling the hashCode method on each of the two objects must produce the same integer result. It is not required that if two objects are unequal according to the equals(java.lang.Object) method, then calling the hashCode method on each of the two objects must produce distinct integer results. However, the programmer should be aware that producing distinct integer results for unequal objects may improve the performance of hashtables. As much as is reasonably practical, the hashCode method defined by class Object does return distinct integers for distinct objects. (This is typically implemented by converting the internal address of the object into an integer, but this implementation technique is not required by the JavaTM programming language.)
    Overrides:
      `hashCode` in class `Object`

  - ### equals

    public boolean equals(Object obj)
    Description copied from class: `Object`
    Indicates whether some other object is "equal to" this one. The equals method implements an equivalence relation: It is reflexive: for any reference value x, x.equals(x) should return true. It is symmetric: for any reference values x and y, x.equals(y) should return true if and only if y.equals(x) returns true. It is transitive: for any reference values x, y, and z, if x.equals(y) returns true and y.equals(z) returns true, then x.equals(z) should return true. It is consistent: for any reference values x and y, multiple invocations of x.equals(y) consistently return true or consistently return false, provided no information used in equals comparisons on the object is modified. For any non-null reference value x, x.equals(null) should return false. The equals method for class Object implements the most discriminating possible equivalence relation on objects; that is, for any reference values x and y, this method returns true if and only if x and y refer to the same object (x==y has the value true).
    Overrides:
      `equals` in class `Object`

  - ### dot

    public static final float dot(Vec3 a, Vec3 b)

  - ### cross

    public static final Vec3 cross(Vec3 a, Vec3 b)

  - ### crossToOut

    public static final void crossToOut(Vec3 a, Vec3 b, Vec3 out)

  - ### crossToOutUnsafe

    public static final void crossToOutUnsafe(Vec3 a, Vec3 b, Vec3 out)